#pragma once

#include <dshow.h>

// guidɓĂȂǉGUID
#ifndef WAVE_FORMAT_AAC
#define WAVE_FORMAT_AAC 0x00FF
#endif
#ifndef MEDIASUBTYPE_AAC
DEFINE_GUID(MEDIASUBTYPE_AAC,WAVE_FORMAT_AAC, 0x000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);
#endif

typedef struct _DIRECTSHOW_FILTER_INFO {
		char m_szFriendryName[120];
		CLSID		class_id;
		void *m_pNextData;
}DIRECTSHOW_FILTER_INFO;

	class CDirectShowUtil
{
public:
	CDirectShowUtil(void);
	~CDirectShowUtil(void);

	void Clear();
	bool FindFilter(const CLSID *pidInType,const CLSID *pidInSubType,const CLSID *pidOutType=NULL,const CLSID *pidOutubType=NULL);
	int GetFilterCount();
#if 0
	bool GetFilterInfo(const int iIndex,CLSID *pidClass=NULL,CStringW *pFriendryName=NULL);
#else
	bool GetFilterInfo(const int iIndex,CLSID *pidClass=NULL,char *pszFriendryName=NULL,int cbFriendryName=0);
#endif
	
	// ֗֐
	static IPin* GetFilterPin(IBaseFilter *pFilter,const PIN_DIRECTION dir,const AM_MEDIA_TYPE *pMediaType);

protected:
#if 0
	struct DIRECTSHOW_FILTER_INFO {
		CStringW	friendry_name;
		CLSID		class_id;
	};

	CArray<DIRECTSHOW_FILTER_INFO> m_FilterClassID;
#else

	DIRECTSHOW_FILTER_INFO *GetFilterClassID(int nIdx);

	DIRECTSHOW_FILTER_INFO *m_pFilterClassID;
	int m_nFilterCount;
#endif
	
};
