#ifndef _CDB_TV_INFOMATION_
#define _CDB_TV_INFOMATION_

#include "CMemoryFileMap.h"
#include "CDBBase.h"

typedef struct _ST_TV_INFOMATION{
	DWORD	dwID;
	BOOL	IsSignal;		//M̗L(TRUE -> LAFALSE -> )
	char	szSvrName[80];	//ǖ
	long	lSpace;			//`l
	long	lChIdx;			//`lCfbNX
	long	lSvrIdx;		//T[rXCfbNX
	long	lSvrID;			//T[rXID
	int		nNIT1;			//\
	int		nNIT2;			//\
	int		nNIT3;			//\
	int		nRmCtrlKeyID;	//\
	DWORD	dwRsv1;
	DWORD	dwRsv2;
	DWORD	dwRsv3;
	DWORD	dwRsv4;
	DWORD	dwRsv5;
}ST_TV_INFOMATION;

typedef struct _ST_TV_INFO_HEADER{
	char	szHeader[32];
	DWORD	dwVer;
	DWORD	dwLastID;
	int		nDatCount;
	long	lCurrentChannel;
	long	 lCurrentSunCh;
	DWORD	dwRsv1;		//\1
	DWORD	dwRsv2;		//\2
}ST_TV_INFO_HEADER;

class CDBTVInfo : public CMemoryFileMap,
				  public CDBBase
{
public:
	CDBTVInfo();
	~CDBTVInfo();
	
	//
	BOOL Init(void);
	BOOL Init(DWORD dwSpace);

	//
	BOOL UnInit(void);

	//ǉ
	BOOL Add(void *pInfo, int cbInfo);
	
	//폜
	BOOL DeleteIdx(int nIdx);

	BOOL DeleteID(DWORD dwID);
	
	//ҏW
	BOOL SetInfoIdx(int nIdx,void *pInfo, int cbInfo);
	
	BOOL SetInfoID(DWORD dwID,void *pInfo, int cbInfo);

	//擾
	BOOL GetInfoIdx(int nIdx,void *pInfo, int cbInfo);
	
	BOOL GetInfoID(DWORD dwID,void *pInfo, int cbInfo);
	
	//擾
	BOOL GetCount(int *pnCount);

	//S̏
	BOOL ClearAllData(void);

	//̎擾(wb_)
	BOOL GetDBVer(DWORD *pdwVer);
	BOOL GetCurrentChannel(long *plCh);
	BOOL SetCurrentChannel(long lCh);

private:

	ST_TV_INFO_HEADER *m_pstTVHeader;
	ST_TV_INFOMATION *m_pstTVInfo;	//er̎ێt@C}bvւ̃|C^

};

#endif
